// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

import com.togethersoft.openapi.ide.project.IdeProjectManagerAccess;

import de.uka.ilkd.key.casetool.FunctionalityOnModel;
import de.uka.ilkd.key.casetool.UMLModelClass;

public class ClassMenuPoint4 extends ClassMenu {

    static File lastDirectory=null;
    
    private File directory;


    public String getMenuEntry(){
	return "DL Proof Obligation";
    }

    protected String runCore(UMLModelClass modelClass){

	if (lastDirectory==null) {
	    String tprFile = IdeProjectManagerAccess
		.getProjectManager().getActiveProject().getFileName();
	    String projectRoot = tprFile.substring
		(0, tprFile.lastIndexOf(File.separator));
	    directory=new File(projectRoot);
	}
	else {
	    directory=lastDirectory;
	}
	JFileChooser jFC = new JFileChooser(directory);
	File sugg=new File(jFC.getCurrentDirectory()+File.separator+"DL_PO.key");
	if (sugg.exists()) {
	    jFC.setSelectedFile(sugg);
	}
	jFC.setDialogTitle("Load a .key file with the current model");
	int load = jFC.showOpenDialog(new JFrame());
	if (load == JFileChooser.APPROVE_OPTION) {
	    File file = jFC.getSelectedFile();    	    
	    return FunctionalityOnModel.proveDLFormula(modelClass, file);
	}
	return "";
    }
}

